#include <iostream.h>
#include "d_Board.h"
//-----------------------------------------------------------------------------------
/* +
 *        
 *
 *  ChessTerminator75
 *   14.1.2007
*/

//---------------------------------------------------------------------------

//       
// 
// level    0-  1- (1-64) 
// 2- (65-128) 3-  (129-131) 4-(132-137)
//  -     .. (1,1)  8 (1,2)  7  ..
//     =1 -  =2   =3    
//   =1-  =2-  =3-  
// =4-   =5-   =6-  

// 
//     
// 0-  1- 2- 3- 4- 5- 6-
//     1- 2-

//	===================================================================
//     
int xy_board_out(int level,int x,int y,int chess_board[]){
    int z=0;
   if (x<1) x=1;
   if (x>8) x=8;
   if (y<1) y=1;
   if (y>8) y=8;
//level 0-------------------   
   if (level==0) z=0;
//level 1 2-------------------
   if ((level>0)&(level<3)){
      z = ((level-1)*64)+((y-1)*8 + x);
   }//if (level>0)&(level<3){
//level 3-------------------
   if (level==3) {
	   if(x>3)x=3;
	   z = ((level-1)*64) + x;
   }
//level 4-------------------
   if (level==4) {
       if(x>6)x=6;
	   z = ((level-2)*64)+3 + x;
   }

 return chess_board[z];
}
//	*******************************************************************

//	===================================================================
//     
//   (1-64)   (65-128)   (129-131)
//  (132-137)
void xy_board_in(int level,int x,int y,int zn,int chess_board[]){
   int z=0;
   if (x<1) x=1;
   if (x>8) x=8;
   if (y<1) y=1;
   if (y>8) y=8;
//level 0-------------------   
   if (level==0) z=0;
//level 1 2-------------------
   if ((level>0)&(level<3)){
      z = ((level-1)*64)+((y-1)*8 + x);
   }//if (level>0)&(level<3){
//level 3-------------------
   if (level==3) {
	   if(x>3)x=3;
	   z = ((level-1)*64) + x;
   }
//level 4-------------------
   if (level==4) {
       if(x>6)x=6;
	   z = ((level-2)*64)+3 + x;
   }
     chess_board[z]=zn;
}//xy_board_in(int level,int x,int y,int z,int chess_board[]){
//	*******************************************************************

//	===================================================================
//  
void print_board(int chess_board[]){
cout <<" "<< "\n";
cout <<"ALL FIGURE----------------------------------"<< "\n";
 cout <<" " << chess_board[0]<< "\n";
  int str=1;
for (int xv=1 ;xv<65;xv++){
  cout <<" " << int_to_char_board(chess_board[xv],chess_board[xv+64]);
  if(str>7){
	cout << "\n";
    str=0;
   }//if(str>9){
str=str+1;
 }//for (int xv=1 ;xv<9;xv++){
}//print_board(int chess_board[]){
//	*******************************************************************

//	===================================================================
//     
// 0- , 1-, 2-, 3-, 4-, 5-, 6-	
char int_to_char_board(int i,int z){
	char ch=' ';
	if (z==0){
	if (i==0) ch='x'; 
    if (i==1) ch='p'; 
    if (i==2) ch='r'; 
    if (i==3) ch='n'; 
    if (i==4) ch='b'; 
    if (i==5) ch='q'; 
    if (i==6) ch='k'; 
	}else{
    if (i==0) ch='x'; 
    if (i==1) ch='P'; 
    if (i==2) ch='R'; 
    if (i==3) ch='N'; 
    if (i==4) ch='B'; 
    if (i==5) ch='Q'; 
    if (i==6) ch='K'; 
    }
	return ch;
}//int_to_char_board(int i)
//	*******************************************************************

//	===================================================================
//     
// 0- , 1-, 2-, 3-, 4-, 5-, 6-	
int char_to_int_board(char f){
	int i=-1;
	if (f=='x') i= 0; 
    if ((f=='p')||(f=='P')) i= 1;  
    if ((f=='r')||(f=='R')) i= 2; 
    if ((f=='n')||(f=='N')) i= 3;  
    if ((f=='b')||(f=='B')) i= 4;  
    if ((f=='q')||(f=='Q')) i= 5;  
    if ((f=='k')||(f=='K')) i= 6;   
	return i;
}//int char_to_int_board(char f){
//	*******************************************************************

//	===================================================================
//	        1 - 	
	char x_to_notation(int x){
			   if (x ==1) return 'a';
			   if (x ==2) return 'b';
			   if (x ==3) return 'c';
			   if (x ==4) return 'd';
			   if (x ==5) return 'e';
			   if (x ==6) return 'f';
			   if (x ==7) return 'g';
			   if (x ==8) return 'h';
			   return 'o';
			  }
//	*******************************************************************

//	===================================================================
//   
void TEST_board_from_fen(int chess_board[]){
cout <<"ALL----------------------------------"<< "\n";
cout <<"COLOR MOVE--------------"<< "\n";
 cout <<" " << chess_board[0]<< "\n";
 int str=1;
cout <<"FIGURE--------------"<< "\n";
for (int xv=1 ;xv<129;xv++){//139
	if (xv==65) {
	  cout <<"COLOR FIGURE--------------"<< "\n";
	}//if (xv==65) {
  cout <<" " << chess_board[xv];
  if(str>7){
	cout << "\n";
    str=0;
   }//if(str>9){
str=str+1;
 }//for (int xv=1 ;xv<9;xv++){
cout <<"PASAGE--------------"<< "\n";
for (int xv=129 ;xv<132;xv++){//139	
  cout <<" " << chess_board[xv];
 }//for (int xv=1 ;xv<9;xv++){
cout << "\n";
cout <<"CASTLING--------------"<< "\n";
for (int xv=132 ;xv<139;xv++){
  cout <<" " << chess_board[xv];
 }//for (int xv=1 ;xv<9;xv++){
cout << "\n";
cout << "****************************************************************\n";
}//void TEST_board_from_fen(){
//	*******************************************************************



